<table mat-table [dataSource]="dataSource" class="mat-elevation-z8" cdkDrag>
  <ng-container matColumnDef="id">
    <th mat-header-cell *matHeaderCellDef>ID.</th>
    <td mat-cell *matCellDef="let i = index;">{{i+1}} </td>
  </ng-container>

  <ng-container matColumnDef="username">
    <th mat-header-cell *matHeaderCellDef>username</th>
    <td mat-cell *matCellDef="let element">{{ element.username }}</td>
  </ng-container>
  <ng-container matColumnDef="password">
    <th mat-header-cell *matHeaderCellDef>password</th>
    <td mat-cell *matCellDef="let element">{{ element.password }}</td>
  </ng-container>
  <ng-container matColumnDef="name">
    <th mat-header-cell *matHeaderCellDef>name</th>
    <td mat-cell *matCellDef="let element">{{ element.name }}</td>
  </ng-container>

  <ng-container matColumnDef="email">
    <th mat-header-cell *matHeaderCellDef>email</th>
    <td mat-cell *matCellDef="let element">{{ element.email }}</td>
  </ng-container>

  <ng-container matColumnDef="role">
    <th mat-header-cell *matHeaderCellDef>role</th>
    <td mat-cell *matCellDef="let element">{{ element.role.name }}</td>
  </ng-container>

  <ng-container matColumnDef="edit">
    <th mat-header-cell *matHeaderCellDef>edit</th>
    <td mat-cell *matCellDef="let element; let i = index;">
      <button
        mat-icon-button
        routerLink="../edit/{{ element.id }}"
      >
        <mat-icon>edit</mat-icon>
      </button>
      <button
        mat-icon-button
        (click)="delUser(element.id)"
      >
        <mat-icon>delete_outline</mat-icon>
      </button>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="displayedColumns;"></tr>
  <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
</table>
